//  The file MUSDAspectSetState.aj was automatically generated using S2A 0.2 beta.
//	Usage of the generated code is permitted for non-commercial research and evaluation purposes.
//	Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package phonebook.aspects;

import phonebook.*;
import mvc.interfaces.*;
import java.util.ArrayList;
import musd.runtime.lib.*;


public aspect MUSDAspectSetState extends MUSDAspect
{


	//Constants for instances, locations and varaibles
	static final int IView_INST_phoneBookView = 0;
	static final int IController_INST_phoneBookController = 1;
	static final int IModel_INST_phoneBookModel = 2;

	static final int Integer_arg_symbolic_state = 0;

	MUSDAspectSetState()
	{
		addMinimalEvent(MUSDMethods.IController_IModel_setState);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 1;
	}

	//Pointcuts and advices:
	pointcut IController_IModel_setState(IController iController, IModel iModel,Integer symbolic_state):
		call(void IModel.setState(..))
		&& target(iModel) && this(iController)  && args(symbolic_state);

	after(IController iController,IModel iModel,Integer symbolic_state):IController_IModel_setState(iController,iModel, symbolic_state)
	{
		ArrayList<Object> args = getArgsList(symbolic_state);
		changeCutState(MUSDMethods.IController_IModel_setState,
				iController,iModel,args);
	}

	pointcut IView_IView_changeView(IView iView,Integer symbolic_state):
		execution(void IView.changeView(..))
		&& target(iView)  && args(symbolic_state);

	after(IView iView,Integer symbolic_state):IView_IView_changeView(iView, symbolic_state)
	{
		ArrayList<Object> args = getArgsList(symbolic_state);
		changeCutState(MUSDMethods.IView_IView_changeView,
				iView,iView,args);
	}

	pointcut IModel_IView_stateHasChanged(IModel iModel, IView iView,Integer symbolic_state):
		call(void IView.stateHasChanged(..))
		&& target(iView) && this(iModel)  && args(symbolic_state);

	after(IModel iModel,IView iView,Integer symbolic_state):IModel_IView_stateHasChanged(iModel,iView, symbolic_state)
	{
		ArrayList<Object> args = getArgsList(symbolic_state);
		changeCutState(MUSDMethods.IModel_IView_stateHasChanged,
				iModel,iView,args);
	}

	// MUSD Logic:
	protected void  changeActiveMUSDCutState(int MUSDm, Object sourceObject, Object targetObject,ActiveMUSDAspect activeMUSD,
		ArrayList args)
	{
		activeMUSD.setLineInstance(IView_INST_phoneBookView,MUSDEnv.getLifeLineInstance("IView"));

		switch (MUSDm)
		{
			case MUSDMethods.IController_IModel_setState:
				if(activeMUSD.instancesEquals(IModel_INST_phoneBookModel,null)
					&& activeMUSD.instancesEquals(IController_INST_phoneBookController,null)
					&& activeMUSD.isInCut(0,0,0))
				{
					activeMUSD.setLineInstance(IModel_INST_phoneBookModel,targetObject);
					activeMUSD.setLineInstance(IController_INST_phoneBookController,sourceObject);
					activeMUSD.setPrivateVariable(Integer_arg_symbolic_state,args.get(0));
					activeMUSD.setCut(0,1,1);
					return;
				}
				break;
			case MUSDMethods.IView_IView_changeView:
				if(activeMUSD.instancesEquals(IView_INST_phoneBookView,sourceObject)
					&& activeMUSD.instancesEquals(IView_INST_phoneBookView,targetObject)
					&& activeMUSD.isInCut(1,1,2)
					&& activeMUSD.variableEquals(Integer_arg_symbolic_state,args.get(0)))
				{
					activeMUSD.setCut(2,1,2);
					break;
				}
				break;
			case MUSDMethods.IModel_IView_stateHasChanged:
				if(activeMUSD.instancesEquals(IModel_INST_phoneBookModel,sourceObject)
					&& activeMUSD.instancesEquals(IView_INST_phoneBookView,targetObject)
					&& activeMUSD.isInCut(0,1,1)
					&& activeMUSD.variableEquals(Integer_arg_symbolic_state,args.get(0)))
				{
					activeMUSD.setCut(1,1,2);
					return;
				}
				break;
			}
		if(activeMUSD.checkViolation())
			activeMUSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMUSDAspect activeMUSD)
	{
		IView phoneBookView = (IView)activeMUSD.getLineInstance(IView_INST_phoneBookView);
		IController phoneBookController = (IController)activeMUSD.getLineInstance(IController_INST_phoneBookController);
		IModel phoneBookModel = (IModel)activeMUSD.getLineInstance(IModel_INST_phoneBookModel);
		Integer state = (Integer) activeMUSD.getPrivateVariable(Integer_arg_symbolic_state);

		switch (conditionNumber)
		{
		}
		return false;
	}

	protected void getActiveMUSDCutState(MUSDMethodSet ME,MUSDMethodSet EE,
			MUSDMethodSet CV,MUSDMethodSet HV,ActiveMUSDAspect activeMUSD)
	{
		IView phoneBookView = (IView)activeMUSD.getLineInstance(IView_INST_phoneBookView);
		IController phoneBookController = (IController)activeMUSD.getLineInstance(IController_INST_phoneBookController);
		IModel phoneBookModel = (IModel)activeMUSD.getLineInstance(IModel_INST_phoneBookModel);
		Integer VAR_symbolic_state = (Integer) activeMUSD.getPrivateVariable(Integer_arg_symbolic_state);

		ArrayList<Object>  args0 = getArgsList(VAR_symbolic_state);
		MUSDMethod MUSDm0 = new MUSDMethod(phoneBookView,phoneBookView,
			MUSDMethods.IView_IView_changeView,args0);// changeView() Monitored
		ArrayList<Object>  args1 = getArgsList(VAR_symbolic_state);
		MUSDMethod MUSDm1 = new MUSDMethod(phoneBookController,phoneBookModel,
			MUSDMethods.IController_IModel_setState,args1);// setState() Monitored
		ArrayList<Object>  args2 = getArgsList(VAR_symbolic_state);
		MUSDMethod MUSDm2 = new MUSDMethod(phoneBookModel,phoneBookView,
			MUSDMethods.IModel_IView_stateHasChanged,args2);// stateHasChanged() Execute

		 if(activeMUSD.isInCut(0,0,0))
		{
				ME.add(MUSDm1);
				CV.add(MUSDm2,MUSDm0);
				return;
		}
		 if(activeMUSD.isInCut(0,1,1))
		{
				EE.add(MUSDm2);
				CV.add(MUSDm1,MUSDm0);
				return;
		}
		 if(activeMUSD.isInCut(1,1,2))
		{
				ME.add(MUSDm0);
				CV.add(MUSDm2,MUSDm1);
				return;
		}
	}
}
