//  The file MUSDAspectUserErrorInput.aj was automatically generated using S2A 0.2 beta.
//	Usage of the generated code is permitted for non-commercial research and evaluation purposes.
//	Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package phonebook.aspects;

import phonebook.*;
import mvc.interfaces.*;
import java.util.ArrayList;
import musd.runtime.lib.*;


public aspect MUSDAspectUserErrorInput extends MUSDAspect
{


	//Constants for instances, locations and varaibles
	static final int PhoneBookView_INST_phoneBookView = 0;
	static final int PhoneBookController_INST_phoneBookController = 1;
	static final int PhoneBookModel_INST_phoneBookModel = 2;

	static final int String_arg_symbolic_input = 0;
	static final int Integer_arg_exact_s0 = 1;

	MUSDAspectUserErrorInput()
	{
		addMinimalEvent(MUSDMethods.PhoneBookView_PhoneBookController_userHasInput);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 2;
	}

	//Pointcuts and advices:
	pointcut PhoneBookView_PhoneBookController_userHasInput(PhoneBookView phoneBookView, PhoneBookController phoneBookController,String symbolic_input):
		call(void PhoneBookController.userHasInput(..))
		&& target(phoneBookController) && this(phoneBookView)  && args(symbolic_input);

	after(PhoneBookView phoneBookView,PhoneBookController phoneBookController,String symbolic_input):PhoneBookView_PhoneBookController_userHasInput(phoneBookView,phoneBookController, symbolic_input)
	{
		ArrayList<Object> args = getArgsList(symbolic_input);
		changeCutState(MUSDMethods.PhoneBookView_PhoneBookController_userHasInput,
				phoneBookView,phoneBookController,args);
	}

	pointcut PhoneBookController_PhoneBookModel_setState(PhoneBookController phoneBookController, PhoneBookModel phoneBookModel,Integer exact_s0):
		call(void PhoneBookModel.setState(..))
		&& target(phoneBookModel) && this(phoneBookController)  && args(exact_s0);

	after(PhoneBookController phoneBookController,PhoneBookModel phoneBookModel,Integer exact_s0):PhoneBookController_PhoneBookModel_setState(phoneBookController,phoneBookModel, exact_s0)
	{
		ArrayList<Object> args = getArgsList(exact_s0);
		changeCutState(MUSDMethods.PhoneBookController_PhoneBookModel_setState,
				phoneBookController,phoneBookModel,args);
	}

	// MUSD Logic:
	protected void  changeActiveMUSDCutState(int MUSDm, Object sourceObject, Object targetObject,ActiveMUSDAspect activeMUSD,
		ArrayList args)
	{
		activeMUSD.setLineInstance(PhoneBookModel_INST_phoneBookModel,MUSDEnv.getLifeLineInstance("PhoneBookModel"));
		activeMUSD.setPrivateVariable(Integer_arg_exact_s0,PhoneBookConstants.STATE_ERROR);

		switch (MUSDm)
		{
			case MUSDMethods.PhoneBookView_PhoneBookController_userHasInput:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_phoneBookController,null)
					&& activeMUSD.instancesEquals(PhoneBookView_INST_phoneBookView,null)
					&& activeMUSD.isInCut(0,0,0))
				{
					activeMUSD.setLineInstance(PhoneBookController_INST_phoneBookController,targetObject);
					activeMUSD.setLineInstance(PhoneBookView_INST_phoneBookView,sourceObject);
					activeMUSD.setPrivateVariable(String_arg_symbolic_input,args.get(0));
					activeMUSD.setCut(1,1,0);
					if(evaluateCondition(1,activeMUSD))
					{
						activeMUSD.setCut(1,2,0);
						return;
					}
					break;
				}
				break;
			case MUSDMethods.PhoneBookController_PhoneBookModel_setState:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_phoneBookController,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_phoneBookModel,targetObject)
					&& activeMUSD.isInCut(1,2,0)
					&& activeMUSD.variableEquals(Integer_arg_exact_s0,args.get(0)))
				{
					activeMUSD.setCut(1,3,1);
					break;
				}
				break;
			}
		if(activeMUSD.checkViolation())
			activeMUSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMUSDAspect activeMUSD)
	{
		PhoneBookView phoneBookView = (PhoneBookView)activeMUSD.getLineInstance(PhoneBookView_INST_phoneBookView);
		PhoneBookController phoneBookController = (PhoneBookController)activeMUSD.getLineInstance(PhoneBookController_INST_phoneBookController);
		PhoneBookModel phoneBookModel = (PhoneBookModel)activeMUSD.getLineInstance(PhoneBookModel_INST_phoneBookModel);
		Integer s0 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s0);
		String input = (String) activeMUSD.getPrivateVariable(String_arg_symbolic_input);

		switch (conditionNumber)
		{
			case 1: 
				return input == null || input.length() == 0;
		}
		return false;
	}

	protected void getActiveMUSDCutState(MUSDMethodSet ME,MUSDMethodSet EE,
			MUSDMethodSet CV,MUSDMethodSet HV,ActiveMUSDAspect activeMUSD)
	{
		PhoneBookView phoneBookView = (PhoneBookView)activeMUSD.getLineInstance(PhoneBookView_INST_phoneBookView);
		PhoneBookController phoneBookController = (PhoneBookController)activeMUSD.getLineInstance(PhoneBookController_INST_phoneBookController);
		PhoneBookModel phoneBookModel = (PhoneBookModel)activeMUSD.getLineInstance(PhoneBookModel_INST_phoneBookModel);
		Integer VAR_exact_s0 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s0);
		String VAR_symbolic_input = (String) activeMUSD.getPrivateVariable(String_arg_symbolic_input);

		ArrayList<Object>  args19 = getArgsList(VAR_symbolic_input);
		MUSDMethod MUSDm19 = new MUSDMethod(phoneBookView,phoneBookController,
			MUSDMethods.PhoneBookView_PhoneBookController_userHasInput,args19);// userHasInput() Monitored
		ArrayList<Object>  args20 = getArgsList(VAR_exact_s0);
		MUSDMethod MUSDm20 = new MUSDMethod(phoneBookController,phoneBookModel,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args20);// setState() Execute

		 if(activeMUSD.isInCut(0,0,0))
		{
				ME.add(MUSDm19);
				CV.add(MUSDm20);
				return;
		}
		 if(activeMUSD.isInCut(1,2,0))
		{
				EE.add(MUSDm20);
				CV.add(MUSDm19);
				return;
		}
	}
}
