//  The file MUSDAspectUserInput.aj was automatically generated using S2A 0.2 beta.
//	Usage of the generated code is permitted for non-commercial research and evaluation purposes.
//	Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package phonebook.aspects;

import phonebook.*;
import mvc.interfaces.*;
import java.util.ArrayList;
import musd.runtime.lib.*;


public aspect MUSDAspectUserInput extends MUSDAspect
{


	//Constants for instances, locations and varaibles
	static final int PhoneBookView_INST_view = 0;
	static final int PhoneBookController_INST_controller = 1;
	static final int PhoneBookModel_INST_model = 2;

	static final int Integer_arg_exact_s8 = 0;
	static final int String_arg_symbolic_input = 1;
	static final int Integer_arg_exact_sEF6 = 2;
	static final int Integer_arg_exact_sA18 = 3;
	static final int Integer_arg_exact_s4 = 4;
	static final int Integer_arg_exact_sC14 = 5;
	static final int Integer_arg_exact_sO10 = 6;
	static final int Integer_arg_exact_s0 = 7;
	static final int Integer_arg_exact_sD12 = 8;
	static final int Integer_arg_exact_state2 = 9;
	static final int Integer_arg_exact_sB16 = 10;

	MUSDAspectUserInput()
	{
		addMinimalEvent(MUSDMethods.PhoneBookView_PhoneBookController_userHasInput);
		numberOfLifeLines = 3;
		numberOfInstances = 3;
		numberOfVariables = 11;
	}

	//Pointcuts and advices:
	pointcut PhoneBookController_PhoneBookModel_saveAll(PhoneBookController phoneBookController, PhoneBookModel phoneBookModel):
		call(void PhoneBookModel.saveAll(..))
		&& target(phoneBookModel) && this(phoneBookController) ;

	after(PhoneBookController phoneBookController,PhoneBookModel phoneBookModel):PhoneBookController_PhoneBookModel_saveAll(phoneBookController,phoneBookModel)
	{
		changeCutState(MUSDMethods.PhoneBookController_PhoneBookModel_saveAll,
				phoneBookController,phoneBookModel,null);
	}

	pointcut PhoneBookController_PhoneBookModel_addAnEntry(PhoneBookController phoneBookController, PhoneBookModel phoneBookModel,String symbolic_input):
		call(void PhoneBookModel.addAnEntry(..))
		&& target(phoneBookModel) && this(phoneBookController)  && args(symbolic_input);

	after(PhoneBookController phoneBookController,PhoneBookModel phoneBookModel,String symbolic_input):PhoneBookController_PhoneBookModel_addAnEntry(phoneBookController,phoneBookModel, symbolic_input)
	{
		ArrayList<Object> args = getArgsList(symbolic_input);
		changeCutState(MUSDMethods.PhoneBookController_PhoneBookModel_addAnEntry,
				phoneBookController,phoneBookModel,args);
	}

	pointcut PhoneBookController_PhoneBookModel_searchPhoneNumber(PhoneBookController phoneBookController, PhoneBookModel phoneBookModel,String symbolic_input):
		call(void PhoneBookModel.searchPhoneNumber(..))
		&& target(phoneBookModel) && this(phoneBookController)  && args(symbolic_input);

	after(PhoneBookController phoneBookController,PhoneBookModel phoneBookModel,String symbolic_input):PhoneBookController_PhoneBookModel_searchPhoneNumber(phoneBookController,phoneBookModel, symbolic_input)
	{
		ArrayList<Object> args = getArgsList(symbolic_input);
		changeCutState(MUSDMethods.PhoneBookController_PhoneBookModel_searchPhoneNumber,
				phoneBookController,phoneBookModel,args);
	}

	pointcut PhoneBookView_PhoneBookController_userHasInput(PhoneBookView phoneBookView, PhoneBookController phoneBookController,String symbolic_input):
		call(void PhoneBookController.userHasInput(..))
		&& target(phoneBookController) && this(phoneBookView)  && args(symbolic_input);

	after(PhoneBookView phoneBookView,PhoneBookController phoneBookController,String symbolic_input):PhoneBookView_PhoneBookController_userHasInput(phoneBookView,phoneBookController, symbolic_input)
	{
		ArrayList<Object> args = getArgsList(symbolic_input);
		changeCutState(MUSDMethods.PhoneBookView_PhoneBookController_userHasInput,
				phoneBookView,phoneBookController,args);
	}

	pointcut PhoneBookController_PhoneBookModel_setState(PhoneBookController phoneBookController, PhoneBookModel phoneBookModel,Integer exact_sA18):
		call(void PhoneBookModel.setState(..))
		&& target(phoneBookModel) && this(phoneBookController)  && args(exact_sA18);

	after(PhoneBookController phoneBookController,PhoneBookModel phoneBookModel,Integer exact_sA18):PhoneBookController_PhoneBookModel_setState(phoneBookController,phoneBookModel, exact_sA18)
	{
		ArrayList<Object> args = getArgsList(exact_sA18);
		changeCutState(MUSDMethods.PhoneBookController_PhoneBookModel_setState,
				phoneBookController,phoneBookModel,args);
	}

	pointcut PhoneBookController_PhoneBookModel_setName(PhoneBookController phoneBookController, PhoneBookModel phoneBookModel,String symbolic_input):
		call(void PhoneBookModel.setName(..))
		&& target(phoneBookModel) && this(phoneBookController)  && args(symbolic_input);

	after(PhoneBookController phoneBookController,PhoneBookModel phoneBookModel,String symbolic_input):PhoneBookController_PhoneBookModel_setName(phoneBookController,phoneBookModel, symbolic_input)
	{
		ArrayList<Object> args = getArgsList(symbolic_input);
		changeCutState(MUSDMethods.PhoneBookController_PhoneBookModel_setName,
				phoneBookController,phoneBookModel,args);
	}

	// MUSD Logic:
	protected void  changeActiveMUSDCutState(int MUSDm, Object sourceObject, Object targetObject,ActiveMUSDAspect activeMUSD,
		ArrayList args)
	{
		activeMUSD.setLineInstance(PhoneBookModel_INST_model,MUSDEnv.getLifeLineInstance("PhoneBookModel"));
		activeMUSD.setPrivateVariable(Integer_arg_exact_s8,PhoneBookConstants.STATE_ADD_NUMBER);
		activeMUSD.setPrivateVariable(Integer_arg_exact_sEF6,PhoneBookConstants.STATE_ERROR);
		activeMUSD.setPrivateVariable(Integer_arg_exact_sA18,PhoneBookConstants.STATE_ERROR);
		activeMUSD.setPrivateVariable(Integer_arg_exact_s4,PhoneBookConstants.STATE_SEARCH);
		activeMUSD.setPrivateVariable(Integer_arg_exact_sC14,PhoneBookConstants.STATE_IDLE);
		activeMUSD.setPrivateVariable(Integer_arg_exact_sO10,PhoneBookConstants.STATE_IDLE);
		activeMUSD.setPrivateVariable(Integer_arg_exact_s0,PhoneBookConstants.STATE_ADD_NAME);
		activeMUSD.setPrivateVariable(Integer_arg_exact_sD12,PhoneBookConstants.STATE_SEARCH_RESULT);
		activeMUSD.setPrivateVariable(Integer_arg_exact_state2,PhoneBookConstants.STATE_EXIT);
		activeMUSD.setPrivateVariable(Integer_arg_exact_sB16,PhoneBookConstants.STATE_EXIT);

		switch (MUSDm)
		{
			case MUSDMethods.PhoneBookController_PhoneBookModel_saveAll:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,26,24))
				{
					activeMUSD.setCut(1,27,25);
					return;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,6,4))
				{
					activeMUSD.setCut(1,7,5);
					return;
				}
				break;
			case MUSDMethods.PhoneBookController_PhoneBookModel_addAnEntry:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,17,15)
					&& activeMUSD.variableEquals(String_arg_symbolic_input,args.get(0)))
				{
					activeMUSD.setCut(1,18,16);
					return;
				}
				break;
			case MUSDMethods.PhoneBookController_PhoneBookModel_searchPhoneNumber:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,20,18)
					&& activeMUSD.variableEquals(String_arg_symbolic_input,args.get(0)))
				{
					activeMUSD.setCut(1,21,19);
					return;
				}
				break;
			case MUSDMethods.PhoneBookView_PhoneBookController_userHasInput:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,null)
					&& activeMUSD.instancesEquals(PhoneBookView_INST_view,null)
					&& activeMUSD.isInCut(0,0,0))
				{
					activeMUSD.setLineInstance(PhoneBookController_INST_controller,targetObject);
					activeMUSD.setLineInstance(PhoneBookView_INST_view,sourceObject);
					activeMUSD.setPrivateVariable(String_arg_symbolic_input,args.get(0));
					activeMUSD.setCut(1,1,0);
					if(evaluateCondition(5,activeMUSD))
					{
						activeMUSD.setCut(1,2,0);
						activeMUSD.setCut(1,2,0);
						if(evaluateCondition(6,activeMUSD))
						{
							activeMUSD.setCut(1,3,1);
							activeMUSD.setCut(1,3,1);
							if(evaluateCondition(7,activeMUSD))
							{
								activeMUSD.setCut(1,4,2);
								return;
							}
							if(evaluateCondition(8,activeMUSD))
							{
								activeMUSD.setCut(1,6,4);
								return;
							}
							if(evaluateCondition(9,activeMUSD))
							{
								activeMUSD.setCut(1,9,7);
								return;
							}
							if(evaluateCondition(10,activeMUSD))
							{
								activeMUSD.setCut(1,11,9);
								return;
							}
							activeMUSD.setCut(1,13,11);
							if(evaluateCondition(10,activeMUSD))
							{
								activeMUSD.setCut(1,32,30);
								break;
							}
							break;
						}
						if(evaluateCondition(12,activeMUSD))
						{
							activeMUSD.setCut(1,14,12);
							return;
						}
						if(evaluateCondition(13,activeMUSD))
						{
							activeMUSD.setCut(1,17,15);
							return;
						}
						if(evaluateCondition(14,activeMUSD))
						{
							activeMUSD.setCut(1,20,18);
							return;
						}
						if(evaluateCondition(15,activeMUSD))
						{
							activeMUSD.setCut(1,23,21);
																activeMUSD.setCut(1,23,21);
																if(evaluateCondition(16,activeMUSD))
																{
																	activeMUSD.setCut(1,24,22);
																	return;
																}
																if(evaluateCondition(8,activeMUSD))
																{
																	activeMUSD.setCut(1,26,24);
																	return;
																}
																if(evaluateCondition(10,activeMUSD))
																{
																	activeMUSD.setCut(1,29,27);
																	return;
																}
																activeMUSD.setCut(1,31,29);
																if(evaluateCondition(10,activeMUSD))
																{
																	activeMUSD.setCut(1,32,30);
																	break;
																}
																break;
						}
						activeMUSD.setCut(1,32,30);
						break;
					}
					break;
				}
				break;
			case MUSDMethods.PhoneBookController_PhoneBookModel_setState:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,24,22)
					&& activeMUSD.variableEquals(Integer_arg_exact_sC14,args.get(0)))
				{
					activeMUSD.setCut(1,25,23);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,31,29);
						activeMUSD.setCut(1,31,29);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,29,27)
					&& activeMUSD.variableEquals(Integer_arg_exact_sA18,args.get(0)))
				{
					activeMUSD.setCut(1,30,28);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,31,29);
						activeMUSD.setCut(1,31,29);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,27,25)
					&& activeMUSD.variableEquals(Integer_arg_exact_sB16,args.get(0)))
				{
					activeMUSD.setCut(1,28,26);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,31,29);
						activeMUSD.setCut(1,31,29);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,15,13)
					&& activeMUSD.variableEquals(Integer_arg_exact_s8,args.get(0)))
				{
					activeMUSD.setCut(1,16,14);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,32,30);
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,18,16)
					&& activeMUSD.variableEquals(Integer_arg_exact_sO10,args.get(0)))
				{
					activeMUSD.setCut(1,19,17);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,32,30);
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,21,19)
					&& activeMUSD.variableEquals(Integer_arg_exact_sD12,args.get(0)))
				{
					activeMUSD.setCut(1,22,20);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,32,30);
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,4,2)
					&& activeMUSD.variableEquals(Integer_arg_exact_s0,args.get(0)))
				{
					activeMUSD.setCut(1,5,3);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,13,11);
						activeMUSD.setCut(1,13,11);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,9,7)
					&& activeMUSD.variableEquals(Integer_arg_exact_s4,args.get(0)))
				{
					activeMUSD.setCut(1,10,8);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,13,11);
						activeMUSD.setCut(1,13,11);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,7,5)
					&& activeMUSD.variableEquals(Integer_arg_exact_state2,args.get(0)))
				{
					activeMUSD.setCut(1,8,6);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,13,11);
						activeMUSD.setCut(1,13,11);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,11,9)
					&& activeMUSD.variableEquals(Integer_arg_exact_sEF6,args.get(0)))
				{
					activeMUSD.setCut(1,12,10);
					if(evaluateCondition(10,activeMUSD))
					{
						activeMUSD.setCut(1,13,11);
						activeMUSD.setCut(1,13,11);
						if(evaluateCondition(10,activeMUSD))
						{
							activeMUSD.setCut(1,32,30);
							break;
						}
						break;
					}
					break;
				}
				break;
			case MUSDMethods.PhoneBookController_PhoneBookModel_setName:
				if(activeMUSD.instancesEquals(PhoneBookController_INST_controller,sourceObject)
					&& activeMUSD.instancesEquals(PhoneBookModel_INST_model,targetObject)
					&& activeMUSD.isInCut(1,14,12)
					&& activeMUSD.variableEquals(String_arg_symbolic_input,args.get(0)))
				{
					activeMUSD.setCut(1,15,13);
					return;
				}
				break;
			}
		if(activeMUSD.checkViolation())
			activeMUSD.completion();
	}

	@SuppressWarnings("unused")
	private boolean evaluateCondition(int conditionNumber,ActiveMUSDAspect activeMUSD)
	{
		PhoneBookView view = (PhoneBookView)activeMUSD.getLineInstance(PhoneBookView_INST_view);
		PhoneBookController controller = (PhoneBookController)activeMUSD.getLineInstance(PhoneBookController_INST_controller);
		PhoneBookModel model = (PhoneBookModel)activeMUSD.getLineInstance(PhoneBookModel_INST_model);
		Integer sA18 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sA18);
		Integer s0 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s0);
		Integer sEF6 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sEF6);
		Integer state2 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_state2);
		String input = (String) activeMUSD.getPrivateVariable(String_arg_symbolic_input);
		Integer s8 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s8);
		Integer sC14 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sC14);
		Integer sO10 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sO10);
		Integer sD12 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sD12);
		Integer sB16 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sB16);
		Integer s4 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s4);

		switch (conditionNumber)
		{
			case 15: 
				return model.getState()==PhoneBookConstants.STATE_SEARCH_RESULT || model.getState()==PhoneBookConstants.STATE_ERROR;
			case 13: 
				return model.getState()==PhoneBookConstants.STATE_ADD_NUMBER;
			case 8: 
				return input.equals(PhoneBookConstants.COMMAND_QUIT_STRING);
			case 9: 
				return input.equals(PhoneBookConstants.COMMAND_SEARCH_STRING);
			case 6: 
				return model.getState()==PhoneBookConstants.STATE_IDLE;
			case 16: 
				return input.equals(PhoneBookConstants.COMMAND_START_STRING);
			case 14: 
				return model.getState()==PhoneBookConstants.STATE_SEARCH;
			case 7: 
				return input.equals(PhoneBookConstants.COMMAND_ADD_STRING);
			case 10: 
				return true;
			case 5: 
				return input != null && input.length() != 0;
			case 12: 
				return model.getState()==PhoneBookConstants.STATE_ADD_NAME;
		}
		return false;
	}

	protected void getActiveMUSDCutState(MUSDMethodSet ME,MUSDMethodSet EE,
			MUSDMethodSet CV,MUSDMethodSet HV,ActiveMUSDAspect activeMUSD)
	{
		PhoneBookView view = (PhoneBookView)activeMUSD.getLineInstance(PhoneBookView_INST_view);
		PhoneBookController controller = (PhoneBookController)activeMUSD.getLineInstance(PhoneBookController_INST_controller);
		PhoneBookModel model = (PhoneBookModel)activeMUSD.getLineInstance(PhoneBookModel_INST_model);
		Integer VAR_exact_sA18 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sA18);
		Integer VAR_exact_s0 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s0);
		Integer VAR_exact_sEF6 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sEF6);
		Integer VAR_exact_state2 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_state2);
		String VAR_symbolic_input = (String) activeMUSD.getPrivateVariable(String_arg_symbolic_input);
		Integer VAR_exact_s8 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s8);
		Integer VAR_exact_sC14 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sC14);
		Integer VAR_exact_sO10 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sO10);
		Integer VAR_exact_sD12 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sD12);
		Integer VAR_exact_sB16 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_sB16);
		Integer VAR_exact_s4 = (Integer) activeMUSD.getPrivateVariable(Integer_arg_exact_s4);

		ArrayList<Object>  args3 = getArgsList(VAR_symbolic_input);
		MUSDMethod MUSDm3 = new MUSDMethod(view,controller,
			MUSDMethods.PhoneBookView_PhoneBookController_userHasInput,args3);// userHasInput() Monitored
		MUSDMethod MUSDm4 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_saveAll,null);// saveAll() Execute
		ArrayList<Object>  args6 = getArgsList(VAR_symbolic_input);
		MUSDMethod MUSDm6 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setName,args6);// setName() Execute
		ArrayList<Object>  args7 = getArgsList(VAR_exact_sC14);
		MUSDMethod MUSDm7 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args7);// setState() Execute
		ArrayList<Object>  args8 = getArgsList(VAR_exact_sA18);
		MUSDMethod MUSDm8 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args8);// setState() Execute
		ArrayList<Object>  args9 = getArgsList(VAR_exact_sB16);
		MUSDMethod MUSDm9 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args9);// setState() Execute
		ArrayList<Object>  args10 = getArgsList(VAR_exact_s8);
		MUSDMethod MUSDm10 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args10);// setState() Execute
		ArrayList<Object>  args11 = getArgsList(VAR_exact_sO10);
		MUSDMethod MUSDm11 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args11);// setState() Execute
		ArrayList<Object>  args12 = getArgsList(VAR_exact_sD12);
		MUSDMethod MUSDm12 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args12);// setState() Execute
		ArrayList<Object>  args13 = getArgsList(VAR_exact_s0);
		MUSDMethod MUSDm13 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args13);// setState() Execute
		ArrayList<Object>  args14 = getArgsList(VAR_exact_s4);
		MUSDMethod MUSDm14 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args14);// setState() Execute
		ArrayList<Object>  args15 = getArgsList(VAR_exact_state2);
		MUSDMethod MUSDm15 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args15);// setState() Execute
		ArrayList<Object>  args16 = getArgsList(VAR_exact_sEF6);
		MUSDMethod MUSDm16 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_setState,args16);// setState() Execute
		ArrayList<Object>  args17 = getArgsList(VAR_symbolic_input);
		MUSDMethod MUSDm17 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_searchPhoneNumber,args17);// searchPhoneNumber() Execute
		ArrayList<Object>  args18 = getArgsList(VAR_symbolic_input);
		MUSDMethod MUSDm18 = new MUSDMethod(controller,model,
			MUSDMethods.PhoneBookController_PhoneBookModel_addAnEntry,args18);// addAnEntry() Execute

		 if(activeMUSD.isInCut(0,0,0))
		{
				ME.add(MUSDm3);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm16,MUSDm13,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,4,2))
		{
				EE.add(MUSDm13);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm16,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,6,4))
		{
				EE.add(MUSDm4);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,7,5))
		{
				EE.add(MUSDm15);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm16,MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,9,7))
		{
				EE.add(MUSDm14);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm4,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,11,9))
		{
				EE.add(MUSDm16);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,14,12))
		{
				EE.add(MUSDm6);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,15,13))
		{
				EE.add(MUSDm10);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm14,MUSDm4,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,17,15))
		{
				EE.add(MUSDm18);
				CV.add(MUSDm9,MUSDm11,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,18,16))
		{
				EE.add(MUSDm11);
				CV.add(MUSDm9,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,20,18))
		{
				EE.add(MUSDm17);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm16,MUSDm13,MUSDm3,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,21,19))
		{
				EE.add(MUSDm12);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm16,MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15);
				return;
		}
		 if(activeMUSD.isInCut(1,24,22))
		{
				EE.add(MUSDm7);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,26,24))
		{
				EE.add(MUSDm4);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,27,25))
		{
				EE.add(MUSDm9);
				CV.add(MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7,MUSDm16);
				CV.add(MUSDm13,MUSDm3,MUSDm17,MUSDm8,MUSDm15,MUSDm12);
				return;
		}
		 if(activeMUSD.isInCut(1,29,27))
		{
				EE.add(MUSDm8);
				CV.add(MUSDm9,MUSDm11,MUSDm18,MUSDm10,MUSDm14,MUSDm4,MUSDm6,MUSDm7);
				CV.add(MUSDm16,MUSDm13,MUSDm3,MUSDm17,MUSDm15,MUSDm12);
				return;
		}
	}
}
