//  The file MUSDCoordinatorAspect.aj was automatically generated using S2A 0.2 beta.
//	Usage of the generated code is permitted for non-commercial research and evaluation purposes.
//	Removing or changing the above comment is prohibited by S2A 0.2 beta license agreement.
//	For information see http://www.wisdom.weizmann.ac.il/~maozs/s2a/

package phonebook.aspects;

import phonebook.*;
import mvc.interfaces.*;
import musd.runtime.lib.*;


public aspect MUSDCoordinatorAspect
{
	declare precedence: MUSDCoordinatorAspect, *;
	ICoordinatorStrategy strategy = new CoordinatorStrategyNaiveImpl();

	private boolean inAfter = false;
	private boolean fromAfter = false;

	public void PhoneBookController.WrappersaveAll(PhoneBookModel phoneBookModel)
	{
		phoneBookModel.saveAll();
	}

	public void PhoneBookController.WrapperaddAnEntry(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.addAnEntry(symbolic_input);
	}

	public void PhoneBookController.WrappersearchPhoneNumber(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.searchPhoneNumber(symbolic_input);
	}

	public void PhoneBookController.WrappersetState(PhoneBookModel phoneBookModel,Integer exact_s0)
	{
		phoneBookModel.setState(exact_s0);
	}

	public void PhoneBookController.WrappersetName(PhoneBookModel phoneBookModel,String symbolic_input)
	{
		phoneBookModel.setName(symbolic_input);
	}

	public void IModel.WrapperstateHasChanged(IView iView,Integer symbolic_state)
	{
		iView.stateHasChanged(symbolic_state);
	}

	pointcut MUSDMessage():
	call(void PhoneBookController.userHasInput(..))
	|| call(void PhoneBookModel.saveAll(..))
	|| execution(void IView.changeView(..))
	|| call(void IView.stateHasChanged(..))
	|| call(void PhoneBookModel.setState(..))
	|| call(void PhoneBookModel.addAnEntry(..))
	|| call(void PhoneBookModel.setName(..))
	|| call(void IModel.setState(..))
	|| call(void PhoneBookModel.searchPhoneNumber(..));


	after (): MUSDMessage()
	{
		if (!fromAfter) {
			fromAfter = true;
			afterImpl();
			fromAfter = false;
		}
	}


	void afterImpl() 
	{
		if (inAfter)
			inAfter = false;
		else inAfter = true;

		MUSDMethodSet monitoringEnabled = new MUSDMethodSet();
		MUSDMethodSet executingEnabled = new MUSDMethodSet();
		MUSDMethodSet coldViolation = new MUSDMethodSet();
		MUSDMethodSet hotViolation = new MUSDMethodSet();

		MUSDAspectSetState.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);
		MUSDAspectUserInput.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);
		MUSDAspectUserErrorInput.aspectOf().getCutState(monitoringEnabled, executingEnabled, coldViolation, hotViolation);

		MUSDMethod MUSDm = strategy.chooseMethod(monitoringEnabled, executingEnabled, coldViolation, hotViolation);

		if(MUSDm != null)
		{
			switch (MUSDm.messageID)
			{
				case MUSDMethods.PhoneBookController_PhoneBookModel_saveAll:
				 ((PhoneBookController)MUSDm.sourceInstance).WrappersaveAll(
					(PhoneBookModel)MUSDm.targetInstance);
				break;
				case MUSDMethods.PhoneBookController_PhoneBookModel_addAnEntry:
				 ((PhoneBookController)MUSDm.sourceInstance).WrapperaddAnEntry(
					(PhoneBookModel)MUSDm.targetInstance
					,(String)MUSDm.args.get(0));
				break;
				case MUSDMethods.PhoneBookController_PhoneBookModel_searchPhoneNumber:
				 ((PhoneBookController)MUSDm.sourceInstance).WrappersearchPhoneNumber(
					(PhoneBookModel)MUSDm.targetInstance
					,(String)MUSDm.args.get(0));
				break;
				case MUSDMethods.PhoneBookController_PhoneBookModel_setState:
				 ((PhoneBookController)MUSDm.sourceInstance).WrappersetState(
					(PhoneBookModel)MUSDm.targetInstance
					,(Integer)MUSDm.args.get(0));
				break;
				case MUSDMethods.PhoneBookController_PhoneBookModel_setName:
				 ((PhoneBookController)MUSDm.sourceInstance).WrappersetName(
					(PhoneBookModel)MUSDm.targetInstance
					,(String)MUSDm.args.get(0));
				break;
				case MUSDMethods.IModel_IView_stateHasChanged:
				 ((IModel)MUSDm.sourceInstance).WrapperstateHasChanged(
					(IView)MUSDm.targetInstance
					,(Integer)MUSDm.args.get(0));
				break;
			}
		}
		if (inAfter)
		{
			this.fromAfter = false;
			afterImpl();
		}
	}
}

